-- 
macroScript ArchedSpline category:"ScriptAttack" tooltip:"ArchedSpline v1.0" Icon: #("ArchedSpline",1) --silentErrors: true
(
global floaterarchedspline --  
global archedsplinepos=[100,100] --  
	
on ischecked return try(execute "floaterarchedspline.isOpen")catch(off) --,    .
on execute do (-- 
if (floaterarchedspline == undefined) then (--     ,      

rollout floaterarchedspline "ArchedSpline 1.0" width:138 height:118 -- 
(--
label lbl_fulllength "Full Length:" pos:[9,8] width:58 height:13
label lblfullheight "Full Height:" pos:[11,28] width:54 height:13
label lbl_archeight "Arc Height:" pos:[11,52] width:54 height:13
label lbl_arcradius "Arc Radius:" pos:[9,72] width:56 height:13
--.       (enabled: false), ..     ,     
spinner spn_fulllength "" pos:[70,5] width:56 height:16 range:[0.001, 100000.0, 100.0] type:#float enabled: false
spinner spn_fullheight "" pos:[70,25] width:56 height:16 range:[0.001, 100000.0, 100.0] type:#float enabled: false
spinner spn_archeight "" pos:[70,49] width:56 height:16 range:[0.001, 100000.0, 100.0] type:#float enabled: false
spinner spn_arcradius "" pos:[70,69] width:56 height:16 range:[0.001, 100000.0, 100.0] type:#float enabled: false
checkbutton btn_create "Create" pos:[8,91] width:118 height:19 enabled: false checked: true ---,    ""
-- 
local isOpen=off --     (/)
local currentarchedspline=0 --   
local win_length, win_height --     

--,      
fn whenchangeselection = (--  ,   
	--         AHeight,             
	if selection.count==1 and (getUserProp selection[1] "AHeight")!=undefined then floaterarchedspline.currentarchedspline=selection[1]
	--   ,     -       a
	a=floaterarchedspline.currentarchedspline
	if isValidNode a then (floaterarchedspline.setcorrectvalues() --   ,    
		floaterarchedspline.onoffspinners true
		)
	else (floaterarchedspline.currentarchedspline=0; floaterarchedspline.onoffspinners false) --   -      
)

fn onoffspinners arg = (--/       
    floaterarchedspline.spn_fulllength.enabled=arg
    floaterarchedspline.spn_fullheight.enabled=arg
    floaterarchedspline.spn_arcradius.enabled=arg
    floaterarchedspline.spn_archeight.enabled=arg
    )
   
fn setcorrectvalues = (--       
    if isValidNode currentarchedspline then (--  
    floaterarchedspline.spn_fulllength.value=getUserProp currentarchedspline "Length"
    floaterarchedspline.spn_fullheight.value=getUserProp currentarchedspline "Height"
    floaterarchedspline.spn_arcradius.value=getUserProp currentarchedspline "ARadius"
    floaterarchedspline.spn_archeight.value=getUserProp currentarchedspline "AHeight"
    )
    )
	
fn editarchedspline wLen wHei wARad wAHei = ( --    4     
    l=wLen/2.0 -- 
    anglealpha=asin(l/wARad) --  
    arc_center=[0, wHei, 0]-[0, wARad, 0] -- 

    ca=arc pos: [0,0,0] radius: wARad from: (90-anglealpha) to: (90+anglealpha) --      
    aw=SplineShape() --    (  )
    addnewspline aw --  
    addKnot aw 1 #corner #line [-l, wHei-wAHei,0] -- 1 
    addKnot aw 1 #corner #line [-l,0,0] -- 2 
    addKnot aw 1 #corner #line [l,0,0] -- 3 
    addKnot aw 1 #corner #line [l, wHei-wAHei,0] -- 4 
    updateShape aw -- 

    ca.pos=arc_center --   
    convertToSplineShape ca --   EDITABLE SPLINE
    addAndWeld aw ca 0.001 --   
    updateShape aw -- 
    aw.wireColor=color 255 0 0 --     (    )
    setUserProp aw "Length" wLen --    
    setUserProp aw "Height" wHei --    
    setUserProp aw "ARadius" wARad --    
    setUserProp aw "AHeight" wAHei --    
    aw --    
    )

fn getcoordmatrix pp = ( --        ( ABC),      0,    
    if pp==0 then ( --  0,             
    pp=#(0,0,0) --   ,             
    pp[1]=getKnotPoint currentarchedspline 1 2 -- A
    pp[2]=getKnotPoint currentarchedspline 1 3 -- B
    pp[3]=getKnotPoint currentarchedspline 1 1 -- C
    )
    in coordsys world ( --         , ..   ABC  BAC
    ppc=(pp[1]+(pp[2]-pp[1])/2) --  O
    win_length=(distance pp[2] pp[1])/2 --  AB
    v1=(pp[3]-ppc) -- OC
    vx=normalize (pp[1]-ppc) -- (  1)  OA,     x  
    vdot=dot v1 vx --   OC   x
    pp4=ppc+vx*vdot --  N
    win_height=distance pp[3] pp4 --  (   C  N)
    vy=normalize (pp[3]-pp4) --  NC,     y  
    vz=normalize (cross vx vy) -- ,   x  y,     z  
    m=matrix3 vx vy vz ppc --  4x3       
    )
    m -- 
    )
	
fn createarchedspline = ( --    
    pp=#(0,0,0); checkpoints=0 --    
    for i=1 to 3 do ( --     
    t=case i of (
        1: " First "
        2: " Second "
        3: " Third "
        )
    txt="Pick"+ t+ "Point" --  :)
    floaterarchedspline.title=txt --      
    txt="\n"+txt --  
   
    --   (     ,     )
    if i==1 then point_pos = pickPoint prompt: txt snap: #3D
   
    -- 1  ,            
    if i==2 and pp[1]!=0 then point_pos = pickPoint prompt: txt snap: #3D rubberBand: pp[1]
   
    -- 1  2  ,              
    if i==3 and pp[2]!=0 and pp[1]!=0 then point_pos = pickPoint prompt: txt snap: #3D rubberBand: (pp[1]+(pp[2]-pp[1])/2)
   
    --    ( ,     -  " ")
    if (classOf point_pos)==Point3 then pp[i]=point_pos else checkpoints=1
    ) -- 
   
    if checkpoints==0 then (--    ,    
    m=getcoordmatrix pp-- ,     (    )
    l=win_length --  
    h=win_length --   
    if win_height<win_length then win_height+=h --     (. )
    win_radius=(l^2+h^2)/(2*h) -- 
    currentarchedspline=editarchedspline (distance pp[2] pp[1]) win_height win_radius h--  (    )
    onoffspinners true--       
    currentarchedspline.transform=m --    
    )
    floaterarchedspline.btn_create.checked=false --           
    floaterarchedspline.title="ArchedSpline 1.0" --  
)
-- 
	
	
on floaterarchedspline open do ( --  
	isOpen=on --,   
	if selection.count==1 and (getUserProp selection[1] "AHeight")!=undefined then ( -- -    
		currentarchedspline=selection[1] --  
		onoffspinners true -- 
		btn_create.checked=false -- ,           
		)
		else createarchedspline() --     
		setcorrectvalues() -- 
	btn_create.enabled=true -- 
	callbacks.removeScripts #selectionSetChanged id: #AWINDOW --  
	
	-- ,      
	callbacks.addscript #selectionSetChanged "floaterarchedspline.whenchangeselection()" id: #AWINDOW
)



on floaterarchedspline close do ( --  
	isOpen=off --,   
	archedsplinepos=GetDialogPos floaterarchedspline --  
	callbacks.removeScripts #selectionSetChanged id: #AWINDOW -- 
	updateToolbarButtons() --  
)
		
on btn_create changed arg do ( --  
    onoffspinners false --   
    createarchedspline() -- 
    setcorrectvalues() -- 
    onoffspinners true --    
)
	
on spn_fulllength changed arg do if isValidNode currentarchedspline then (--    
    if spn_archeight.value<=spn_arcradius.value then (--    
    m=getcoordmatrix 0 --   
    win_height=getUserProp currentarchedspline "Height" --
    h=getUserProp currentarchedspline "AHeight" -- 
    l=arg/2 -- 
    win_radius=(l^2+h^2)/(2*h) --
    delete currentarchedspline -- 
    currentarchedspline=editarchedspline arg win_height win_radius h --   
    currentarchedspline.transform=m --   
    )
    setcorrectvalues() --  
)
   
on spn_fullheight changed arg do if isValidNode currentarchedspline then (--    
    if arg>=spn_archeight.value then (--    
    m=getcoordmatrix 0 --   
    win_length=getUserProp currentarchedspline "Length" --
    win_radius=getUserProp currentarchedspline "ARadius" -- 
    h=getUserProp currentarchedspline "AHeight" -- 
    l=win_length/2 -- 
    delete currentarchedspline -- 
    currentarchedspline=editarchedspline win_length arg win_radius h -- 
    currentarchedspline.transform=m --   
    )
    setcorrectvalues() -- 
)

on spn_archeight changed arg do if isValidNode currentarchedspline then (--     
    if arg<=spn_arcradius.value then (--    
    m=getcoordmatrix 0 --   
    win_length=getUserProp currentarchedspline "Length" --
    win_height=getUserProp currentarchedspline "Height" --
    h=arg -- 
    l=win_length/2 -- 
    win_radius=(l^2+h^2)/(2*h) -- 
    delete currentarchedspline -- 
    currentarchedspline=editarchedspline win_length win_height win_radius arg -- 
    currentarchedspline.transform=m --  
    )
    setcorrectvalues() -- 
)
   
on spn_arcradius changed arg do if isValidNode currentarchedspline then (--     
    if arg>=(spn_fulllength.value/2) then (--    
    m=getcoordmatrix 0 -- 
    len=getUserProp currentarchedspline "Length" --
    win_height=getUserProp currentarchedspline "Height" --
    l=len/2 -- 
    h=arg-sqrt(arg^2-l^2) -- 
    delete currentarchedspline -- 
    currentarchedspline=editarchedspline len win_height arg h -- 
    currentarchedspline.transform=m --  
    )
    setcorrectvalues() -- 
)

) -- 
updateToolbarButtons() --  


)
--      ,    ,     .
if floaterarchedspline.isOpen then (archedsplinepos=GetDialogPos floaterarchedspline; destroyDialog floaterarchedspline; updateToolbarButtons())
else CreateDialog floaterarchedspline pos: archedsplinepos --   -     
) --   (execute)
) -- 
